module GI.WebKit2WebExtension.Objects.DOMDocument where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype DOMDocument = DOMDocument (ForeignPtr DOMDocument)
instance GObject DOMDocument where
class GObject o => DOMDocumentK o
instance (GObject o, IsDescendantOf DOMDocument o) => DOMDocumentK o
data DOMDocumentActiveElementPropertyInfo
data DOMDocumentAnchorsPropertyInfo
data DOMDocumentAppletsPropertyInfo
data DOMDocumentBodyPropertyInfo
data DOMDocumentCharacterSetPropertyInfo
data DOMDocumentCharsetPropertyInfo
data DOMDocumentChildElementCountPropertyInfo
data DOMDocumentChildrenPropertyInfo
data DOMDocumentCompatModePropertyInfo
data DOMDocumentContentTypePropertyInfo
data DOMDocumentCookiePropertyInfo
data DOMDocumentCurrentScriptPropertyInfo
data DOMDocumentDefaultCharsetPropertyInfo
data DOMDocumentDefaultViewPropertyInfo
data DOMDocumentDoctypePropertyInfo
data DOMDocumentDocumentElementPropertyInfo
data DOMDocumentDocumentUriPropertyInfo
data DOMDocumentDomainPropertyInfo
data DOMDocumentFirstElementChildPropertyInfo
data DOMDocumentFormsPropertyInfo
data DOMDocumentHeadPropertyInfo
data DOMDocumentHiddenPropertyInfo
data DOMDocumentImagesPropertyInfo
data DOMDocumentImplementationPropertyInfo
data DOMDocumentInputEncodingPropertyInfo
data DOMDocumentLastElementChildPropertyInfo
data DOMDocumentLastModifiedPropertyInfo
data DOMDocumentLinksPropertyInfo
data DOMDocumentOriginPropertyInfo
data DOMDocumentPointerLockElementPropertyInfo
data DOMDocumentPreferredStylesheetSetPropertyInfo
data DOMDocumentReadyStatePropertyInfo
data DOMDocumentReferrerPropertyInfo
data DOMDocumentScrollingElementPropertyInfo
data DOMDocumentSelectedStylesheetSetPropertyInfo
data DOMDocumentStyleSheetsPropertyInfo
data DOMDocumentTitlePropertyInfo
data DOMDocumentUrlPropertyInfo
data DOMDocumentVisibilityStatePropertyInfo
data DOMDocumentWebkitCurrentFullScreenElementPropertyInfo
data DOMDocumentWebkitFullScreenKeyboardInputAllowedPropertyInfo
data DOMDocumentWebkitFullscreenElementPropertyInfo
data DOMDocumentWebkitFullscreenEnabledPropertyInfo
data DOMDocumentWebkitIsFullScreenPropertyInfo
data DOMDocumentXmlEncodingPropertyInfo
data DOMDocumentXmlStandalonePropertyInfo
data DOMDocumentXmlVersionPropertyInfo
data DOMDocumentAdoptNodeMethodInfo
data DOMDocumentCreateAttributeMethodInfo
data DOMDocumentCreateAttributeNsMethodInfo
data DOMDocumentCreateCdataSectionMethodInfo
data DOMDocumentCreateCommentMethodInfo
data DOMDocumentCreateCssStyleDeclarationMethodInfo
data DOMDocumentCreateDocumentFragmentMethodInfo
data DOMDocumentCreateElementMethodInfo
data DOMDocumentCreateElementNsMethodInfo
data DOMDocumentCreateEntityReferenceMethodInfo
data DOMDocumentCreateEventMethodInfo
data DOMDocumentCreateExpressionMethodInfo
data DOMDocumentCreateNodeIteratorMethodInfo
data DOMDocumentCreateNsResolverMethodInfo
data DOMDocumentCreateProcessingInstructionMethodInfo
data DOMDocumentCreateRangeMethodInfo
data DOMDocumentCreateTextNodeMethodInfo
data DOMDocumentCreateTreeWalkerMethodInfo
data DOMDocumentElementFromPointMethodInfo
data DOMDocumentEvaluateMethodInfo
data DOMDocumentExecCommandMethodInfo
data DOMDocumentGetActiveElementMethodInfo
data DOMDocumentGetAnchorsMethodInfo
data DOMDocumentGetAppletsMethodInfo
data DOMDocumentGetBodyMethodInfo
data DOMDocumentGetCharacterSetMethodInfo
data DOMDocumentGetCharsetMethodInfo
data DOMDocumentGetCookieMethodInfo
data DOMDocumentGetDefaultCharsetMethodInfo
data DOMDocumentGetDefaultViewMethodInfo
data DOMDocumentGetDoctypeMethodInfo
data DOMDocumentGetDocumentElementMethodInfo
data DOMDocumentGetDocumentUriMethodInfo
data DOMDocumentGetDomainMethodInfo
data DOMDocumentGetElementByIdMethodInfo
data DOMDocumentGetElementsByClassNameMethodInfo
data DOMDocumentGetElementsByNameMethodInfo
data DOMDocumentGetElementsByTagNameMethodInfo
data DOMDocumentGetElementsByTagNameNsMethodInfo
data DOMDocumentGetFormsMethodInfo
data DOMDocumentGetHeadMethodInfo
data DOMDocumentGetImagesMethodInfo
data DOMDocumentGetImplementationMethodInfo
data DOMDocumentGetInputEncodingMethodInfo
data DOMDocumentGetLastModifiedMethodInfo
data DOMDocumentGetLinksMethodInfo
data DOMDocumentGetOverrideStyleMethodInfo
data DOMDocumentGetPreferredStylesheetSetMethodInfo
data DOMDocumentGetReadyStateMethodInfo
data DOMDocumentGetReferrerMethodInfo
data DOMDocumentGetSelectedStylesheetSetMethodInfo
data DOMDocumentGetStyleSheetsMethodInfo
data DOMDocumentGetTitleMethodInfo
data DOMDocumentGetUrlMethodInfo
data DOMDocumentGetXmlEncodingMethodInfo
data DOMDocumentGetXmlStandaloneMethodInfo
data DOMDocumentGetXmlVersionMethodInfo
data DOMDocumentHasFocusMethodInfo
data DOMDocumentImportNodeMethodInfo
data DOMDocumentQueryCommandEnabledMethodInfo
data DOMDocumentQueryCommandIndetermMethodInfo
data DOMDocumentQueryCommandStateMethodInfo
data DOMDocumentQueryCommandSupportedMethodInfo
data DOMDocumentQueryCommandValueMethodInfo
data DOMDocumentQuerySelectorMethodInfo
data DOMDocumentQuerySelectorAllMethodInfo
data DOMDocumentSetBodyMethodInfo
data DOMDocumentSetCharsetMethodInfo
data DOMDocumentSetCookieMethodInfo
data DOMDocumentSetDocumentUriMethodInfo
data DOMDocumentSetSelectedStylesheetSetMethodInfo
data DOMDocumentSetTitleMethodInfo
data DOMDocumentSetXmlStandaloneMethodInfo
data DOMDocumentSetXmlVersionMethodInfo
